﻿/**
 * FLARToolKit example launcher
 * --------------------------------------------------------------------------------
 * Copyright (C)2010 saqoosha
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * For further information please contact.
 *	http://www.libspark.org/wiki/saqoosha/FLARToolKit
 *	<saq(at)saqoosha.net>
 * 
 * Contributors
 *  saqoosha
 *  rokubou
 */
 package {

	import flash.events.Event;
	import org.papervision3d.objects.parsers.DAE;
	import flash.display.MovieClip;
	import org.papervision3d.materials.MovieMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.events.FileLoadEvent;
	import com.greensock.*;
	import com.greensock.easing.*;
	import com.greensock.plugins.*;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.primitives.Plane;
	import flash.utils.ByteArray;
	import flash.media.*;
	
	[SWF(width=640, height=480, backgroundColor=0x808080, frameRate=30)]
	
	public class FLARToolKit_ColladaData extends PV3DARApp {
		
		[Embed(source="bottlenose.xml", mimeType="application/octet-stream")]
		private var theModel:Class;
		
		private var loopAqua:loop_aqua;
		private var channelAqua:SoundChannel;
		private var click1:click1sfx;
		private var click2:click2sfx;
		private var squeak1:squeak1sfx;
		private var squeak2:squeak2sfx;
		private var splosh:sploshsfx;
		private var emerge:emergesfx;
		private var channelVoice:SoundChannel;
		
		
		
		private var model:DisplayObject3D;

		private var _dolphin:DAE;
		
		private var head1:DisplayObject3D;
		private var head2:DisplayObject3D;
		private var mouth:DisplayObject3D;
			
		private var body1:DisplayObject3D;
		private var body2:DisplayObject3D;
		private var body3:DisplayObject3D;
		private var body4:DisplayObject3D;
		private var body5:DisplayObject3D;
		private var body6:DisplayObject3D;
		
		private var flipperR:DisplayObject3D;
		private var flipperL:DisplayObject3D;
		

		
		public function FLARToolKit_ColladaData() {
			
			addEventListener(Event.INIT, _onInit);
			init('camera_para.xml', 'flarlogo.xml');
		}
		
		private function _onInit(e:Event):void {
			trace("init");
			var dolphinShadow:MovieClip = new dolphinshadow();
			var dolphinShadowMat:MovieMaterial = new MovieMaterial(dolphinShadow,true);
			dolphinShadowMat.smooth = true;
			var _shadow:Plane = new Plane(dolphinShadowMat, 136, 360,3,3);
			_shadow.scale = 0.6;
			_shadow.y = 25;
			_shadow.rotationX = 180;
			_shadow.x = 70;
			
			var dolphinSkin:MovieClip = new dolphinskin();
			var dolphinMat:MovieMaterial = new MovieMaterial(dolphinSkin,true);
			dolphinMat.animated = true;
			dolphinMat.smooth = true;
			
			//replace any uv mats with movieclips
			var materialsListDolphin:MaterialsList = new MaterialsList();
			materialsListDolphin.addMaterial( dolphinMat, "bottlenosedolphin" );
			
			_dolphin = new DAE();
			
			var byteArray:ByteArray = new theModel();
			_dolphin.load(byteArray, materialsListDolphin);
			
			//_dolphin.load('bottlenose.xml', materialsListDolphin);
			_dolphin.scale = 15;
			_dolphin.rotationX = 90;
			_dolphin.rotationZ = 90;
			_dolphin.x = 70;
			_dolphin.z = 70;
			
			
			_dolphin.addEventListener(FileLoadEvent.LOAD_COMPLETE, handleLoadDolphinComplete);
			
			model = new DisplayObject3D;
			model.addChild(_shadow);
			model.addChild(_dolphin);
			
			_markerNode.addChild(model);
			
			
			loopAqua = new loop_aqua();
			channelAqua = loopAqua.play(0,999);
			
			click1 = new click1sfx();
			click2 = new click2sfx();
			squeak1 = new squeak1sfx();
			squeak2 = new squeak2sfx();
			splosh = new sploshsfx();
			emerge = new emergesfx();
			
			
		}
		
		private function handleLoadDolphinComplete(e:Event):void {
			trace("Dolphin Loaded");
			head1 = _dolphin.getChildByName("head1", true);
			head2 = _dolphin.getChildByName("head2", true);
			mouth = _dolphin.getChildByName("mouth", true);
			body1 = _dolphin.getChildByName("body1", true);
			body2 = _dolphin.getChildByName("body2", true);
			body3 = _dolphin.getChildByName("body3", true);
			body4 = _dolphin.getChildByName("body4", true);
			body5 = _dolphin.getChildByName("body5", true);
			body6 = _dolphin.getChildByName("body6", true);
			flipperR = _dolphin.getChildByName("flipperR", true);
			flipperL = _dolphin.getChildByName("flipperL", true);
			
			addEventListener(Event.ENTER_FRAME, _update);
			
			TweenMax.to(head1, 0.2, {rotationY:5, ease:Expo.easeInOut});
			TweenMax.to(body1, 0.2, {rotationY:-1, ease:Expo.easeInOut});
			TweenMax.to(body1, 0.2, {z:-0.2, ease:Expo.easeInOut});
			TweenMax.to(flipperR, 0.2, {rotationY:5, ease:Expo.easeInOut});
			TweenMax.to(flipperL, 0.2, {rotationY:5, ease:Expo.easeInOut});
			TweenMax.to(body2, 0.2, {rotationY:-5, ease:Expo.easeInOut});
			TweenMax.to(body3, 0.2, {rotationY:-7, ease:Expo.easeInOut});
			TweenMax.to(body4, 0.2, {rotationY:-10, ease:Expo.easeInOut});
			TweenMax.to(body5, 0.2, {rotationY:-13, ease:Expo.easeInOut});
			TweenMax.to(body6, 0.2, {rotationY:-25, ease:Expo.easeInOut});
			
			TweenMax.to(body2, 0.2, {rotationZ:-2, ease:Quad.easeInOut});
			TweenMax.to(body3, 0.2, {rotationZ:-4, ease:Quad.easeInOut});
			TweenMax.to(body4, 0.2, {rotationZ:-7, ease:Quad.easeInOut});
					
					
			TweenMax.to(head1, 0.7, {rotationY:-5, ease:Quad.easeInOut,repeat:-1,yoyo:true,delay:0.8});
			TweenMax.to(body1, 0.7, {z:0.1, ease:Quad.easeInOut,repeat:-1,yoyo:true,delay:1.1});
			TweenMax.to(flipperR, 0.7, {rotationY:-10, ease:Linear.easeInOut,repeat:-1,yoyo:true,delay:1});
			TweenMax.to(flipperL, 0.7, {rotationY:-10, ease:Linear.easeInOut,repeat:-1,yoyo:true,delay:1});
			TweenMax.to(body1, 0.7, {rotationY:4, ease:Quad.easeInOut,repeat:-1,yoyo:true,delay:1.2});
			TweenMax.to(body2, 0.7, {rotationY:4, ease:Quad.easeInOut,repeat:-1,yoyo:true,delay:1.1});
			TweenMax.to(body3, 0.7, {rotationY:6, ease:Linear.easeInOut,repeat:-1,yoyo:true,delay:1.2});
			TweenMax.to(body4, 0.7, {rotationY:8, ease:Linear.easeInOut,repeat:-1,yoyo:true,delay:1.3});
			TweenMax.to(body5, 0.7, {rotationY:10, ease:Linear.easeInOut,repeat:-1,yoyo:true,delay:1.4});
			TweenMax.to(body6, 0.7, {rotationY:20, ease:Linear.easeInOut,repeat:-1,yoyo:true,delay:1.5});
		}
		
		private function _update(e:Event):void {
			model.rotationZ -= 1.0
			
			if(Math.random()*1<0.1){
				animateDolphin(Math.ceil(Math.random()*6));
			}
			
		}
		
		private function animateDolphin(anim:Number):void {
			trace("animate");
			
			switch(anim){
				
				case 1:
					var randNum:Number = (Math.random()*40) - 20;
					var timing:Number = (Math.random()*2) + 2;
					trace(randNum);
					TweenMax.to(head2, timing, {rotationZ:randNum, ease:Cubic.easeInOut});
				break;
				case 2:
					var randNum:Number = (Math.random()*30) - 10;
					var timing:Number = (Math.random()*2) + 2;
					
					TweenMax.to(head2, timing, {rotationY:randNum, ease:Cubic.easeInOut});
				break;
				case 3:
					var randNum:Number = (Math.random()*30) - 15;
					var timing:Number = (Math.random()*2) + 2;
					
					TweenMax.to(head2, timing, {rotationX:randNum, ease:Cubic.easeInOut});
				break;
				case 4:
					var randNum:Number = (Math.random()*30);
					TweenMax.to(mouth, 0.7, {rotationY:randNum, ease:Expo.easeInOut});
					dolphinSpeak();
				break;
				case 5:
					TweenMax.to(mouth, 0.5, {rotationY:0, ease:Cubic.easeIn});
				break;
				
				case 6:
					TweenMax.to(head2, 0.3, {rotationX:-4, ease:Quad.easeInOut,repeat:4,yoyo:true});
					TweenMax.to(mouth, 0.4, {rotationY:3, ease:Expo.easeInOut,repeat:3,yoyo:true});
					TweenMax.to(head2, 0.3, {rotationX:-4, ease:Quad.easeInOut,delay:1.2});
					TweenMax.to(mouth, 0.4, {rotationY:30, ease:Expo.easeInOut,delay:1.2});
					
				break;				
			}
		}
		
		private function dolphinSpeak():void {
			switch(Math.ceil(Math.random()*4)){
				case 1:
				channelVoice = click1.play();
				break;
				case 2:
				channelVoice = click2.play();
				break;
				case 3:
				channelVoice = squeak1.play();
				break;
				case 4:
				channelVoice = squeak2.play();
				break;
			}
		}
	}
}
